#ifndef __VOLUME_H__
#define __VOLUME_H__

#include "vvvoldesc.h"

enum ShrinkMode{
        NEAREST = 0,
	BILINEAR
};

// file format parameter
enum VolOrganization {
	VOL_ORG_SEP = 0,	// saving all channels of one pixel separately
	VOL_ORG_MIX		// saving all channels of one pixel together ( as normal image format does/ readable by human eye )
};

class Volume {
public:
	Volume();
	virtual ~Volume();

	vvVolDesc* getVolDesc() { return vd; }
 
	virtual bool save(char *filename, vvVolDesc *vd) = 0;
	virtual bool load(char *filename, vvVolDesc *vd) = 0;
	virtual FILE *saveAppend (FILE *fp, char *filename, int volSize[3], vvVolDesc *vdOut, int BPV, uchar *raw) = 0;

	virtual FILE *loadHeaders(char *filename) = 0;

	void resizeByCPUAndSaveBricksToOneVolume( char *filename, char *FNInit, char *FNFileType,
//						  float zoomX, float zoomY, Image::ShrinkMode mode ) {
						  float zoom[3], int mode );
	void resizeByCPUAndSaveBricksToOneVolume_sep( char *filename, char *FNInit, char *FNFileType,
						      float zoom[3], int mode );
	void resizeByCPUAndSaveBricksToOneVolume_mix( char *filename, char *FNInit, char *FNFileType,
						      float zoom[3], int mode );

	// volume properties
	int getBrickSize();
	void setBrickSize(int bS);
	unsigned int getVolOrganization() { return volOrganization; }
	void setVolOrganization(unsigned int volOrg);

	// Data source file related
	void closeFile() { if(fpVol != NULL) fclose(fpVol); }

public:
	vvVolDesc *vd;

	// volume properties
	int brickSize;
	int nBricks[3];
	int remaingPixels[3];
	int sliceBytes;
	int BPV;
	int volOrganization;

	// Data source file related
	FILE *fpVol;
	int whereData;

private:
	inline int round(float a) { return (a>0)? (int)(a+.5): (int)(a-.5); }
};

#endif
